<template>
  <q-page class="flex flex-center justify-between column">
   <div class="top">
    <h1>connexion gps</h1>
  </div>

  <div class="login">
    <form class="bottom_forms__child" action="">
      <q-input filled v-model="loginName" label="nom utilisateur" />
      <q-input filled v-model="loginPass" label="mot de pass" />
      <q-btn @click.prevent="connexion" label="se connecter" type="submit" color="primary"/>
    </form>
  </div>

  <div class="bottom_forms">
    <input class="bottom_forms__child" v-model="modifName" placeholder="modification du nom">
    <form class="bottom_forms__child" action="">
      <input v-model="addnew" placeholder="nouveau nom">
      <button @click.prevent="addUser">confirmer</button>
    </form>
  </div>
  </q-page>
</template>

<script>
console.log('coucou');
import { defineComponent, ref } from 'vue';

export default defineComponent({

  name: 'helloWorld',
  props: {
    msg: String,
  },
  setup() {
    // const users = ref([{username:'testone'}, {username:'testtwo'}])
    const users = ref([]);
    const addnew = ref('');
    const modifName = ref('');
    const loginName = ref('');
    const loginPass = ref('');

    const fetchUsers = () => {
      fetch('http://localhost:8080/users/6234924b35e8c3add810b079/champs/6257f3e9b00fc0262eeee0ae')
        .then((res) => res.json())
        .then((json) => users.value = json)
        .catch((err) => console.log(err));
    };

    const addUser = () => {
      const requestOptions = {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify({ username: addnew.value }),
      };
      fetch('http://localhost:8080/users', requestOptions)
        .then((response) => response.json())
        .then((data) => (users.value.push(data)));
    };

    const deleteUser = (userId) => {
      // users.value.push({username: addnew})
      console.log(`http://localhost:8080/users/${userId}`);
      const requestOptionsdelete = {
        method: 'DELETE',
      };
      fetch(`http://localhost:8080/users/${userId}`, requestOptionsdelete)
        .then(() => {
          const idx = users.value.findIndex((user) => user.username === userId);
          users.value.splice(idx, 1);
        });
    };

    const modifUser = (oldUserName) => {
      console.log(`http://localhost:8080/users/${oldUserName}`);

      console.log(modifName.value);

      const requestOptionsModif = {
        method: 'PUT',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify({ username: modifName.value }),
      };
      fetch(`http://localhost:8080/users/${oldUserName}`, requestOptionsModif)
        .then((response) => response.json())
      // .then(data => (this.postId = data.id));
        .then((data) => {
          const idx = users.value.findIndex((user) => user.username === oldUserName);
          users.value[idx] = data;
        });
    };

    const connexion = () => {
      // console.log(loginName.value);
      // console.log(loginPass.value);
      const requestOptionsConn = {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify({
          username: loginName.value,
          password: loginPass.value,
        }),
      };
      fetch('http://localhost:8080/login', requestOptionsConn)
        .then((response) => response.json())
        .then((data) => {
          users.value.push(data);
          console.log(data);
        });
    };

    return {
      users,
      addnew,
      modifName,
      loginName,
      loginPass,
      fetchUsers,
      addUser,
      deleteUser,
      modifUser,
      connexion,
    };
  },
});
</script>
<style scoped>
</style>
